// RRConBarBone.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

int main(int argc, char* argv[])
{
	// start COM machinery
	CoInitialize(NULL);
	// check useage of  #import in StdAfx.h
	// in the Server the global class is called Application
	// VB adds an underscore so it becomes _Application to the
	// outside world. This COM class is wrapped by the #import directive
	// into a smartpointer class _ApplicationPtr
	_ApplicationPtr pApp;
	// create an instance
	// you name the server as you would name it creating it in VB
	// using CreateObject. No surprice here since the same machinery
	// is doing the job.
	try{   
		pApp.CreateInstance("RRServer.Application");
		// now call any property
		if(pApp){
			pApp->Show();
			// no good to use any methods after 
			// pApp->Show() has returned, since it is hidden now
			// and migth even be destroyed
			pApp->SetPeer(123); // bad idea
			// release interface
			// this will be done automatically when the 
			// smartpointer goes out of scope
			// However we are law abiding programmers and clean up ourselfs 
			pApp.Release();
		}
	}
	catch (...){
			MessageBox(NULL, "Hoppalla, something went wrong", "",MB_ICONEXCLAMATION);
	}
	// stop COM machinery
	CoUninitialize();
	return 0;
}

